import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Hero here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Hero extends Actor
{
    int collisionCountdown = 0;  // Need to slowdown losing health
    /**
     * Act - do whatever the Hero wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if( collisionCountdown > 0 )
        {
            collisionCountdown--;
        }
        else
        {
            handleCollisions();
        }
        
        followMouse();
    }   
    
    private void followMouse()
    {
        MouseInfo mi = Greenfoot.getMouseInfo();
        if( mi != null ) setLocation(mi.getX(), mi.getY());
    }
    
    private void handleCollisions()
    {
        Actor enemy = getOneIntersectingObject(Enemy.class);
        if( enemy != null )
        {
            HBWorld w = (HBWorld) getWorld();
            w.subtractHealth(10);
            collisionCountdown = 20;
        }
    }
}
